'/***************************************************************************
'* KeyInfo.VB
'*
'* Developed by     : RAINBOW SYSTEMS
'* Creation Date    : 21-3-2002              
'* (C) Copyright 1991-2002 Rainbow Technologies, Inc. All rights reserved.
'*
'* Purpose     : GetKeyInfo API user input output form

'****************************************************************************/

Public Class KeyInfo
    Inherits System.Windows.Forms.Form
    Private NextKey As Int16 = 0
    Public Const NSPRO_MONITOR_MAX_BUFFER_SIZE As Integer = 204

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents KeyID As System.Windows.Forms.TextBox
    Friend WithEvents HardLimit As System.Windows.Forms.TextBox
    Friend WithEvents LicUse As System.Windows.Forms.TextBox
    Friend WithEvents NumTimeOut As System.Windows.Forms.TextBox
    Friend WithEvents HighUse As System.Windows.Forms.TextBox
    Friend WithEvents Button1 As System.Windows.Forms.Button
    Friend WithEvents Button2 As System.Windows.Forms.Button

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(KeyInfo))
        Me.HighUse = New System.Windows.Forms.TextBox()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.KeyID = New System.Windows.Forms.TextBox()
        Me.NumTimeOut = New System.Windows.Forms.TextBox()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.HardLimit = New System.Windows.Forms.TextBox()
        Me.LicUse = New System.Windows.Forms.TextBox()
        Me.Button1 = New System.Windows.Forms.Button()
        Me.Button2 = New System.Windows.Forms.Button()
        Me.Label4 = New System.Windows.Forms.Label()
        Me.Label5 = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'HighUse
        '
        Me.HighUse.Location = New System.Drawing.Point(120, 166)
        Me.HighUse.Multiline = True
        Me.HighUse.Name = "HighUse"
        Me.HighUse.ReadOnly = True
        Me.HighUse.Size = New System.Drawing.Size(144, 23)
        Me.HighUse.TabIndex = 9
        Me.HighUse.Text = ""
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(8, 30)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(64, 15)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "DevID(Hex) "
        '
        'KeyID
        '
        Me.KeyID.Location = New System.Drawing.Point(120, 24)
        Me.KeyID.Multiline = True
        Me.KeyID.Name = "KeyID"
        Me.KeyID.Size = New System.Drawing.Size(144, 23)
        Me.KeyID.TabIndex = 5
        Me.KeyID.Text = "FFFF"
        '
        'NumTimeOut
        '
        Me.NumTimeOut.Location = New System.Drawing.Point(120, 132)
        Me.NumTimeOut.Multiline = True
        Me.NumTimeOut.Name = "NumTimeOut"
        Me.NumTimeOut.ReadOnly = True
        Me.NumTimeOut.Size = New System.Drawing.Size(144, 23)
        Me.NumTimeOut.TabIndex = 8
        Me.NumTimeOut.Text = ""
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(8, 64)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(64, 15)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Hard Limit"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(8, 98)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(70, 15)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Lic in Use"
        '
        'HardLimit
        '
        Me.HardLimit.Location = New System.Drawing.Point(120, 58)
        Me.HardLimit.Multiline = True
        Me.HardLimit.Name = "HardLimit"
        Me.HardLimit.ReadOnly = True
        Me.HardLimit.Size = New System.Drawing.Size(144, 23)
        Me.HardLimit.TabIndex = 6
        Me.HardLimit.Text = ""
        '
        'LicUse
        '
        Me.LicUse.Location = New System.Drawing.Point(120, 92)
        Me.LicUse.Multiline = True
        Me.LicUse.Name = "LicUse"
        Me.LicUse.ReadOnly = True
        Me.LicUse.Size = New System.Drawing.Size(144, 23)
        Me.LicUse.TabIndex = 7
        Me.LicUse.Text = ""
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(32, 208)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(75, 25)
        Me.Button1.TabIndex = 10
        Me.Button1.Text = "&NextKey"
        '
        'Button2
        '
        Me.Button2.Location = New System.Drawing.Point(160, 208)
        Me.Button2.Name = "Button2"
        Me.Button2.Size = New System.Drawing.Size(75, 25)
        Me.Button2.TabIndex = 11
        Me.Button2.Text = "&Cancel"
        '
        'Label4
        '
        Me.Label4.Location = New System.Drawing.Point(8, 132)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(90, 15)
        Me.Label4.TabIndex = 3
        Me.Label4.Text = "Num Timed Out"
        '
        'Label5
        '
        Me.Label5.Location = New System.Drawing.Point(8, 166)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(90, 15)
        Me.Label5.TabIndex = 4
        Me.Label5.Text = "Highest in Use"
        '
        'KeyInfo
        '
        Me.AutoScale = False
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(272, 245)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.Button2, Me.Button1, Me.HighUse, Me.NumTimeOut, Me.LicUse, Me.HardLimit, Me.KeyID, Me.Label5, Me.Label4, Me.Label3, Me.Label2, Me.Label1})
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "KeyInfo"
        Me.Text = "KeyInfo"
        Me.ResumeLayout(False)

    End Sub

#End Region

    '**************************************************************************
    '* Procedure: Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitBtn.Click
    '*
    '* Purpose  : Called on NextKey button click
    '*
    ' Descrip   :RNBOsproKeyInfo API call here
    '****************************************************************************/
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim i As Int16
        Dim status As System.Int16
        Dim sdeveloperId As String = ""
        Dim developerId As Int32 = 0
        Dim bKeyBuffer() As Byte = New Byte(NSPRO_MONITOR_MAX_BUFFER_SIZE) {}
        'Get DevID entered by user as string
        sdeveloperId = KeyID.Text
        'Perform validation for DEVID string value and convert into integer.
        i = form1.isValidData(sdeveloperId, 4, developerId)

        If (i = 1) Then 'If DevID is blank

            MessageBox.Show("Specify DeveloperID to proceed.", "GetKeyInfo", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i = 2) Then 'If DevID string is of invalid length

            MessageBox.Show("DeveloperID must be in hex with length not exceeding 4 digits.", "GetKeyInfo")
            Return
        End If
        If (i = 3) Then 'If DevID string is not valid HexString

            MessageBox.Show("DeveloperID must be in hex with length not exceeding 4 digits.", "GetKeyInfo")
            Return
        End If
        NextKey = NextKey + 1 'Increment value by one to get Next KeyInfo 

        '**************RNBOsproGetKeyInfo API **********************/
        status = Superpro.RNBOsproGetKeyInfo(Superpro.packet, developerId, NextKey, bKeyBuffer)
        'If API get success
        If status = 0 Then
            Dim monitorInfo As Superpro.MonitorInfo = New Superpro.MonitorInfo()
            'Extract Keyinfo value from KeyInfo structure
            monitorInfo.GetMonitorInfo(bKeyBuffer)
            'Display Key info value in output box
            KeyID.Text = Hex(monitorInfo.sproKeyMonitorInfo.developerId)
            If (monitorInfo.sproKeyMonitorInfo.hardLimit = -1) Then
                HardLimit.Text = "65535"
            Else
                HardLimit.Text = CStr(CInt(monitorInfo.sproKeyMonitorInfo.hardLimit))
            End If
            'HardLimit.Text = CStr(monitorInfo.sproKeyMonitorInfo.hardLimit)
            LicUse.Text = CStr(monitorInfo.sproKeyMonitorInfo.inUse)
            NumTimeOut.Text = CStr(monitorInfo.sproKeyMonitorInfo.numTimeOut)
            HighUse.Text = CStr(monitorInfo.sproKeyMonitorInfo.highestUse)
        Else '//If API get fail
            NextKey = NextKey - 1 ' decrement value by one
            MessageBox.Show("GetKeyInfo failed! Return code is " + CStr(status) + ".", "GetKeyInfo", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If


    End Sub

    '**************************************************************************
    '* Procedure: Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitBtn.Click
    '*
    '* Purpose  : Called at when user click CANCEL button
    '*
    ' Descrip   :clear Key info output box and close keyinfo Form
    '****************************************************************************/
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'assign blank string for diffrent output box
        KeyID.Text = ""
        HardLimit.Text = ""
        LicUse.Text = ""
        NumTimeOut.Text = ""
        NumTimeOut.Text = ""
        HighUse.Text = ""
        Close()
    End Sub

    '**************************************************************************
    '* Procedure: KeyInfo_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitBtn.Click
    '*
    '* Purpose  : Called at form load time
    '*
    ' Descrip   :assign some default value in input box for KeyInfo API
    '****************************************************************************/
    Private Sub KeyInfo_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        KeyID.Text = "FFFF"
        NextKey = 0
    End Sub
End Class
