'/***************************************************************************
'* SPROEVAL_mainForm.VB
'*
'* Developed by     : RAINBOW SYSTEMS
'* Creation Date    : 21-3-2002              
'* (C) Copyright 1991-2002 Rainbow Technologies, Inc. All rights reserved.
'*
'* Description : SentinelSuperPro Evaluation Program for WIN16/WIN32s/WIN64-XP in C-Sharp .NET plateform .
'*
'* Purpose     : To demostrate the SentinelSuperPro API for VB.NET languages
'*               running under Windows.
'
'****************************************************************************/
'Include name space
Imports System
Imports System.Text
'**************************************************************************
'* CLASS: form1 
'* Purpose  : main class for MainForm 
'*
'****************************************************************************/

Public Class form1
    Inherits System.Windows.Forms.Form
    Dim AE As New System.Text.ASCIIEncoding()
    Public Shared Key_WritePW As Boolean = False
    Public Shared Key_OWritePW As Boolean = False
    Public Shared WritePW As Int32 = 0 'Key write password
    Public Shared OverWritePW1 As Int32 = 0 'Key Overwrite password1
    Public Shared OverWritePW2 As Int32 = 0 ' Key Overwrite password2
    Public Shared AP1 As Int32 = 0 'Activate password1
    Friend WithEvents ServerName As System.Windows.Forms.ComboBox
    Public Shared AP2 As Int32 = 0 'Activate password2

    Public Const MIN_QUERYDATA_LENGTH As Integer = 8
    Public Const VALIDDATA_LENGTH As Integer = 4
    Public Const CELLADDRESS_LENGTH As Integer = 2
    Public Const MIN_ACCESSCODE_RANGE As Integer = 0
    Public Const MAX_ACCESSCODE_RANGE As Integer = 3

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents sproLogo As System.Windows.Forms.PictureBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
        Friend WithEvents APIGroupBox As System.Windows.Forms.GroupBox
    Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
    Friend WithEvents MiscGroupBox As System.Windows.Forms.GroupBox
    Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
    Friend WithEvents FormatPkt As System.Windows.Forms.Button
    Friend WithEvents InitializeBtn As System.Windows.Forms.Button
    Friend WithEvents SetProtocol As System.Windows.Forms.Button
    Friend WithEvents SetContactSrvBtn As System.Windows.Forms.Button
    Friend WithEvents FindFirstBtn As System.Windows.Forms.Button
    Friend WithEvents FindNextBtn As System.Windows.Forms.Button
    Friend WithEvents GetContactSrv As System.Windows.Forms.Button
    Friend WithEvents HeartBeat As System.Windows.Forms.Button
    Friend WithEvents ReadBtn As System.Windows.Forms.Button
    Friend WithEvents XReadBtn As System.Windows.Forms.Button
    Friend WithEvents WriteBtn As System.Windows.Forms.Button
    Friend WithEvents OverwriteBtn As System.Windows.Forms.Button
    Friend WithEvents QueryBtn As System.Windows.Forms.Button
    Friend WithEvents ActivateBtn As System.Windows.Forms.Button
    Friend WithEvents DecrementBtn As System.Windows.Forms.Button
    Friend WithEvents VersionBtn As System.Windows.Forms.Button
    Friend WithEvents GetHardLmt As System.Windows.Forms.Button
    Friend WithEvents StatusBtn As System.Windows.Forms.Button
    Friend WithEvents KeyInfo As System.Windows.Forms.Button
    Friend WithEvents GetSubLicBtn As System.Windows.Forms.Button
    Friend WithEvents ReleaseLicBtn As System.Windows.Forms.Button
    Friend WithEvents EnumSever As System.Windows.Forms.Button
    Friend WithEvents ViewBtn As System.Windows.Forms.Button
    Friend WithEvents PasswordBtn As System.Windows.Forms.Button
    Friend WithEvents ExitBtn As System.Windows.Forms.Button
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents CellNumber As System.Windows.Forms.TextBox
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents AccessCode As System.Windows.Forms.TextBox
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents Input As System.Windows.Forms.TextBox
    Friend WithEvents Label6 As System.Windows.Forms.Label
    Friend WithEvents Output As System.Windows.Forms.TextBox
    Friend WithEvents Label7 As System.Windows.Forms.Label
    Friend WithEvents Label8 As System.Windows.Forms.Label
    Friend WithEvents ComboBoxProtocolFlag As System.Windows.Forms.ComboBox
    Friend WithEvents Label9 As System.Windows.Forms.Label
        Friend WithEvents StatusLine As System.Windows.Forms.ListBox

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(form1))
        Me.Label4 = New System.Windows.Forms.Label()
        Me.Label5 = New System.Windows.Forms.Label()
        Me.Label6 = New System.Windows.Forms.Label()
        Me.Label7 = New System.Windows.Forms.Label()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.MiscGroupBox = New System.Windows.Forms.GroupBox()
        Me.PasswordBtn = New System.Windows.Forms.Button()
        Me.ViewBtn = New System.Windows.Forms.Button()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.ServerName = New System.Windows.Forms.ComboBox()
        Me.GetSubLicBtn = New System.Windows.Forms.Button()
        Me.GetContactSrv = New System.Windows.Forms.Button()
        Me.InitializeBtn = New System.Windows.Forms.Button()
        Me.SetProtocol = New System.Windows.Forms.Button()
        Me.GroupBox1 = New System.Windows.Forms.GroupBox()
        Me.StatusLine = New System.Windows.Forms.ListBox()
        Me.Label9 = New System.Windows.Forms.Label()
        Me.ComboBoxProtocolFlag = New System.Windows.Forms.ComboBox()
        Me.Label8 = New System.Windows.Forms.Label()
        Me.Output = New System.Windows.Forms.TextBox()
        Me.Input = New System.Windows.Forms.TextBox()
        Me.AccessCode = New System.Windows.Forms.TextBox()
        Me.CellNumber = New System.Windows.Forms.TextBox()
        Me.ReleaseLicBtn = New System.Windows.Forms.Button()
        Me.ActivateBtn = New System.Windows.Forms.Button()
        Me.XReadBtn = New System.Windows.Forms.Button()
        Me.FindNextBtn = New System.Windows.Forms.Button()
        Me.sproLogo = New System.Windows.Forms.PictureBox()
        Me.StatusBtn = New System.Windows.Forms.Button()
        Me.DecrementBtn = New System.Windows.Forms.Button()
        Me.FormatPkt = New System.Windows.Forms.Button()
        Me.OverwriteBtn = New System.Windows.Forms.Button()
        Me.VersionBtn = New System.Windows.Forms.Button()
        Me.APIGroupBox = New System.Windows.Forms.GroupBox()
        Me.EnumSever = New System.Windows.Forms.Button()
        Me.KeyInfo = New System.Windows.Forms.Button()
        Me.GetHardLmt = New System.Windows.Forms.Button()
        Me.QueryBtn = New System.Windows.Forms.Button()
        Me.WriteBtn = New System.Windows.Forms.Button()
        Me.ReadBtn = New System.Windows.Forms.Button()
        Me.HeartBeat = New System.Windows.Forms.Button()
        Me.FindFirstBtn = New System.Windows.Forms.Button()
        Me.SetContactSrvBtn = New System.Windows.Forms.Button()
        Me.ExitBtn = New System.Windows.Forms.Button()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.GroupBox2 = New System.Windows.Forms.GroupBox()
        Me.GroupBox3 = New System.Windows.Forms.GroupBox()
        Me.ViewList = New System.Windows.Forms.ListBox()
        Me.MiscGroupBox.SuspendLayout()
        Me.GroupBox1.SuspendLayout()
        Me.APIGroupBox.SuspendLayout()
        Me.GroupBox2.SuspendLayout()
        Me.GroupBox3.SuspendLayout()
        Me.SuspendLayout()
        '
        'Label4
        '
        Me.Label4.Location = New System.Drawing.Point(126, 30)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(73, 15)
        Me.Label4.TabIndex = 2
        Me.Label4.Text = "Access Code"
        '
        'Label5
        '
        Me.Label5.Location = New System.Drawing.Point(8, 59)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(30, 15)
        Me.Label5.TabIndex = 4
        Me.Label5.Text = "Input"
        '
        'Label6
        '
        Me.Label6.Location = New System.Drawing.Point(8, 88)
        Me.Label6.Name = "Label6"
        Me.Label6.Size = New System.Drawing.Size(40, 15)
        Me.Label6.TabIndex = 6
        Me.Label6.Text = "Output"
        '
        'Label7
        '
        Me.Label7.Location = New System.Drawing.Point(8, 127)
        Me.Label7.Name = "Label7"
        Me.Label7.Size = New System.Drawing.Size(40, 15)
        Me.Label7.TabIndex = 8
        Me.Label7.Text = "Status"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(64, 16)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(208, 16)
        Me.Label1.TabIndex = 1
        Me.Label1.Text = "Sentinel SuperPro Evaluation Program."
        '
        'MiscGroupBox
        '
        Me.MiscGroupBox.Controls.AddRange(New System.Windows.Forms.Control() {Me.PasswordBtn, Me.ViewBtn})
        Me.MiscGroupBox.Location = New System.Drawing.Point(624, 328)
        Me.MiscGroupBox.Name = "MiscGroupBox"
        Me.MiscGroupBox.Size = New System.Drawing.Size(126, 91)
        Me.MiscGroupBox.TabIndex = 2
        Me.MiscGroupBox.TabStop = False
        Me.MiscGroupBox.Text = "Miscellaneous"
        '
        'PasswordBtn
        '
        Me.PasswordBtn.Location = New System.Drawing.Point(8, 50)
        Me.PasswordBtn.Name = "PasswordBtn"
        Me.PasswordBtn.Size = New System.Drawing.Size(110, 25)
        Me.PasswordBtn.TabIndex = 1
        Me.PasswordBtn.Text = "Pa&sswords"
        '
        'ViewBtn
        '
        Me.ViewBtn.Location = New System.Drawing.Point(8, 24)
        Me.ViewBtn.Name = "ViewBtn"
        Me.ViewBtn.Size = New System.Drawing.Size(110, 25)
        Me.ViewBtn.TabIndex = 0
        Me.ViewBtn.Text = "Ke&yView"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(8, 30)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(44, 15)
        Me.Label3.TabIndex = 0
        Me.Label3.Text = "Cell No."
        '
        'ServerName
        '
        Me.ServerName.DropDownWidth = 191
        Me.ServerName.Items.AddRange(New Object() {"RNBO_STANDALONE", "RNBO_SPN_DRIVER", "RNBO_SPN_LOCAL", "RNBO_SPN_BROADCAST", "RNBO_SPN_ALL_MODES", "RNBO_SPN_SERVER_MODES", "NO-NET"})
        Me.ServerName.Location = New System.Drawing.Point(60, 193)
        Me.ServerName.Name = "ServerName"
        Me.ServerName.Size = New System.Drawing.Size(191, 21)
        Me.ServerName.TabIndex = 6
        '
        'GetSubLicBtn
        '
        Me.GetSubLicBtn.Location = New System.Drawing.Point(119, 168)
        Me.GetSubLicBtn.Name = "GetSubLicBtn"
        Me.GetSubLicBtn.Size = New System.Drawing.Size(110, 25)
        Me.GetSubLicBtn.TabIndex = 19
        Me.GetSubLicBtn.Text = "GetSu&bLicense"
        '
        'GetContactSrv
        '
        Me.GetContactSrv.Location = New System.Drawing.Point(8, 72)
        Me.GetContactSrv.Name = "GetContactSrv"
        Me.GetContactSrv.Size = New System.Drawing.Size(110, 25)
        Me.GetContactSrv.TabIndex = 6
        Me.GetContactSrv.Text = "&GetContactServer"
        Me.GetContactSrv.TextAlign = System.Drawing.ContentAlignment.TopLeft
        '
        'InitializeBtn
        '
        Me.InitializeBtn.Location = New System.Drawing.Point(119, 24)
        Me.InitializeBtn.Name = "InitializeBtn"
        Me.InitializeBtn.Size = New System.Drawing.Size(110, 25)
        Me.InitializeBtn.TabIndex = 1
        Me.InitializeBtn.Text = "Initiali&ze"
        '
        'SetProtocol
        '
        Me.SetProtocol.Location = New System.Drawing.Point(230, 24)
        Me.SetProtocol.Name = "SetProtocol"
        Me.SetProtocol.Size = New System.Drawing.Size(110, 25)
        Me.SetProtocol.TabIndex = 2
        Me.SetProtocol.Text = "Se&tProtocol"
        '
        'GroupBox1
        '
        Me.GroupBox1.Controls.AddRange(New System.Windows.Forms.Control() {Me.ServerName, Me.StatusLine, Me.Label9, Me.ComboBoxProtocolFlag, Me.Label8, Me.Label7, Me.Output, Me.Label6, Me.Input, Me.Label5, Me.AccessCode, Me.Label4, Me.CellNumber, Me.Label3})
        Me.GroupBox1.Location = New System.Drawing.Point(360, 328)
        Me.GroupBox1.Name = "GroupBox1"
        Me.GroupBox1.Size = New System.Drawing.Size(259, 233)
        Me.GroupBox1.TabIndex = 1
        Me.GroupBox1.TabStop = False
        Me.GroupBox1.Text = "Input/Output Information"
        '
        'StatusLine
        '
        Me.StatusLine.BackColor = System.Drawing.SystemColors.InactiveBorder
        Me.StatusLine.Location = New System.Drawing.Point(60, 114)
        Me.StatusLine.Name = "StatusLine"
        Me.StatusLine.Size = New System.Drawing.Size(191, 43)
        Me.StatusLine.TabIndex = 4
        '
        'Label9
        '
        Me.Label9.Location = New System.Drawing.Point(8, 200)
        Me.Label9.Name = "Label9"
        Me.Label9.Size = New System.Drawing.Size(40, 15)
        Me.Label9.TabIndex = 12
        Me.Label9.Text = "Server "
        '
        'ComboBoxProtocolFlag
        '
        Me.ComboBoxProtocolFlag.AllowDrop = True
        Me.ComboBoxProtocolFlag.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.ComboBoxProtocolFlag.DropDownWidth = 191
        Me.ComboBoxProtocolFlag.Items.AddRange(New Object() {"NSPRO_TCP_PROTOCOL ", "NSPRO_IPX_PROTOCOL ", "NSPRO_NETBEUI_PROTOCOL ", "NSPRO_SAP_PROTOCOL "})
        Me.ComboBoxProtocolFlag.Location = New System.Drawing.Point(60, 166)
        Me.ComboBoxProtocolFlag.Name = "ComboBoxProtocolFlag"
        Me.ComboBoxProtocolFlag.Size = New System.Drawing.Size(191, 21)
        Me.ComboBoxProtocolFlag.TabIndex = 5
        '
        'Label8
        '
        Me.Label8.Location = New System.Drawing.Point(8, 166)
        Me.Label8.Name = "Label8"
        Me.Label8.Size = New System.Drawing.Size(48, 15)
        Me.Label8.TabIndex = 10
        Me.Label8.Text = "Protocol"
        '
        'Output
        '
        Me.Output.Location = New System.Drawing.Point(60, 83)
        Me.Output.Multiline = True
        Me.Output.Name = "Output"
        Me.Output.ReadOnly = True
        Me.Output.Size = New System.Drawing.Size(191, 23)
        Me.Output.TabIndex = 3
        Me.Output.Text = ""
        '
        'Input
        '
        Me.Input.Location = New System.Drawing.Point(60, 54)
        Me.Input.Multiline = True
        Me.Input.Name = "Input"
        Me.Input.Size = New System.Drawing.Size(191, 23)
        Me.Input.TabIndex = 2
        Me.Input.Text = ""
        '
        'AccessCode
        '
        Me.AccessCode.Location = New System.Drawing.Point(210, 25)
        Me.AccessCode.Multiline = True
        Me.AccessCode.Name = "AccessCode"
        Me.AccessCode.Size = New System.Drawing.Size(41, 23)
        Me.AccessCode.TabIndex = 1
        Me.AccessCode.Text = ""
        '
        'CellNumber
        '
        Me.CellNumber.Location = New System.Drawing.Point(60, 25)
        Me.CellNumber.Multiline = True
        Me.CellNumber.Name = "CellNumber"
        Me.CellNumber.Size = New System.Drawing.Size(41, 23)
        Me.CellNumber.TabIndex = 0
        Me.CellNumber.Text = ""
        '
        'ReleaseLicBtn
        '
        Me.ReleaseLicBtn.Location = New System.Drawing.Point(230, 168)
        Me.ReleaseLicBtn.Name = "ReleaseLicBtn"
        Me.ReleaseLicBtn.Size = New System.Drawing.Size(110, 25)
        Me.ReleaseLicBtn.TabIndex = 20
        Me.ReleaseLicBtn.Text = "Re&leaseLicense"
        '
        'ActivateBtn
        '
        Me.ActivateBtn.Location = New System.Drawing.Point(119, 120)
        Me.ActivateBtn.Name = "ActivateBtn"
        Me.ActivateBtn.Size = New System.Drawing.Size(110, 25)
        Me.ActivateBtn.TabIndex = 13
        Me.ActivateBtn.Text = "&Activate"
        '
        'XReadBtn
        '
        Me.XReadBtn.Location = New System.Drawing.Point(8, 96)
        Me.XReadBtn.Name = "XReadBtn"
        Me.XReadBtn.Size = New System.Drawing.Size(110, 25)
        Me.XReadBtn.TabIndex = 9
        Me.XReadBtn.Text = "E&xtendedRead"
        '
        'FindNextBtn
        '
        Me.FindNextBtn.Location = New System.Drawing.Point(230, 48)
        Me.FindNextBtn.Name = "FindNextBtn"
        Me.FindNextBtn.Size = New System.Drawing.Size(110, 25)
        Me.FindNextBtn.TabIndex = 5
        Me.FindNextBtn.Text = "Find&NextUnit"
        '
        'sproLogo
        '
        Me.sproLogo.Image = CType(resources.GetObject("sproLogo.Image"), System.Drawing.Bitmap)
        Me.sproLogo.Location = New System.Drawing.Point(24, 16)
        Me.sproLogo.Name = "sproLogo"
        Me.sproLogo.Size = New System.Drawing.Size(32, 32)
        Me.sproLogo.TabIndex = 0
        Me.sproLogo.TabStop = False
        '
        'StatusBtn
        '
        Me.StatusBtn.Location = New System.Drawing.Point(230, 144)
        Me.StatusBtn.Name = "StatusBtn"
        Me.StatusBtn.Size = New System.Drawing.Size(110, 25)
        Me.StatusBtn.TabIndex = 17
        Me.StatusBtn.Text = "GetF&ullStatus"
        '
        'DecrementBtn
        '
        Me.DecrementBtn.Location = New System.Drawing.Point(230, 120)
        Me.DecrementBtn.Name = "DecrementBtn"
        Me.DecrementBtn.Size = New System.Drawing.Size(110, 25)
        Me.DecrementBtn.TabIndex = 14
        Me.DecrementBtn.Text = "&Decrement"
        '
        'FormatPkt
        '
        Me.FormatPkt.Location = New System.Drawing.Point(8, 24)
        Me.FormatPkt.Name = "FormatPkt"
        Me.FormatPkt.Size = New System.Drawing.Size(110, 25)
        Me.FormatPkt.TabIndex = 0
        Me.FormatPkt.Text = "Format&Packet"
        '
        'OverwriteBtn
        '
        Me.OverwriteBtn.Location = New System.Drawing.Point(230, 96)
        Me.OverwriteBtn.Name = "OverwriteBtn"
        Me.OverwriteBtn.Size = New System.Drawing.Size(110, 25)
        Me.OverwriteBtn.TabIndex = 11
        Me.OverwriteBtn.Text = "&Overwrite"
        '
        'VersionBtn
        '
        Me.VersionBtn.Location = New System.Drawing.Point(8, 144)
        Me.VersionBtn.Name = "VersionBtn"
        Me.VersionBtn.Size = New System.Drawing.Size(110, 25)
        Me.VersionBtn.TabIndex = 15
        Me.VersionBtn.Text = "Get&Version"
        '
        'APIGroupBox
        '
        Me.APIGroupBox.Controls.AddRange(New System.Windows.Forms.Control() {Me.EnumSever, Me.ReleaseLicBtn, Me.GetSubLicBtn, Me.KeyInfo, Me.StatusBtn, Me.GetHardLmt, Me.VersionBtn, Me.DecrementBtn, Me.ActivateBtn, Me.QueryBtn, Me.OverwriteBtn, Me.WriteBtn, Me.XReadBtn, Me.ReadBtn, Me.HeartBeat, Me.GetContactSrv, Me.FindNextBtn, Me.FindFirstBtn, Me.SetContactSrvBtn, Me.SetProtocol, Me.InitializeBtn, Me.FormatPkt})
        Me.APIGroupBox.Location = New System.Drawing.Point(8, 328)
        Me.APIGroupBox.Name = "APIGroupBox"
        Me.APIGroupBox.Size = New System.Drawing.Size(350, 233)
        Me.APIGroupBox.TabIndex = 0
        Me.APIGroupBox.TabStop = False
        Me.APIGroupBox.Text = "SuperPro APIs"
        '
        'EnumSever
        '
        Me.EnumSever.Location = New System.Drawing.Point(8, 192)
        Me.EnumSever.Name = "EnumSever"
        Me.EnumSever.Size = New System.Drawing.Size(110, 25)
        Me.EnumSever.TabIndex = 21
        Me.EnumSever.Text = "&EnumSever"
        '
        'KeyInfo
        '
        Me.KeyInfo.Location = New System.Drawing.Point(8, 168)
        Me.KeyInfo.Name = "KeyInfo"
        Me.KeyInfo.Size = New System.Drawing.Size(110, 25)
        Me.KeyInfo.TabIndex = 18
        Me.KeyInfo.Text = "Get&KeyInfo"
        '
        'GetHardLmt
        '
        Me.GetHardLmt.Location = New System.Drawing.Point(119, 144)
        Me.GetHardLmt.Name = "GetHardLmt"
        Me.GetHardLmt.Size = New System.Drawing.Size(110, 25)
        Me.GetHardLmt.TabIndex = 16
        Me.GetHardLmt.Text = "GetHardLi&mit"
        '
        'QueryBtn
        '
        Me.QueryBtn.Location = New System.Drawing.Point(8, 120)
        Me.QueryBtn.Name = "QueryBtn"
        Me.QueryBtn.Size = New System.Drawing.Size(110, 25)
        Me.QueryBtn.TabIndex = 12
        Me.QueryBtn.Text = "&Query"
        '
        'WriteBtn
        '
        Me.WriteBtn.Location = New System.Drawing.Point(119, 96)
        Me.WriteBtn.Name = "WriteBtn"
        Me.WriteBtn.Size = New System.Drawing.Size(110, 25)
        Me.WriteBtn.TabIndex = 10
        Me.WriteBtn.Text = "&Write"
        '
        'ReadBtn
        '
        Me.ReadBtn.Location = New System.Drawing.Point(230, 72)
        Me.ReadBtn.Name = "ReadBtn"
        Me.ReadBtn.Size = New System.Drawing.Size(110, 25)
        Me.ReadBtn.TabIndex = 8
        Me.ReadBtn.Text = "&Read"
        '
        'HeartBeat
        '
        Me.HeartBeat.Location = New System.Drawing.Point(119, 72)
        Me.HeartBeat.Name = "HeartBeat"
        Me.HeartBeat.Size = New System.Drawing.Size(110, 25)
        Me.HeartBeat.TabIndex = 7
        Me.HeartBeat.Text = "Set&HeartBeat"
        '
        'FindFirstBtn
        '
        Me.FindFirstBtn.Location = New System.Drawing.Point(119, 48)
        Me.FindFirstBtn.Name = "FindFirstBtn"
        Me.FindFirstBtn.Size = New System.Drawing.Size(110, 25)
        Me.FindFirstBtn.TabIndex = 4
        Me.FindFirstBtn.Text = "&FindFirstUnit"
        '
        'SetContactSrvBtn
        '
        Me.SetContactSrvBtn.Location = New System.Drawing.Point(8, 48)
        Me.SetContactSrvBtn.Name = "SetContactSrvBtn"
        Me.SetContactSrvBtn.Size = New System.Drawing.Size(110, 25)
        Me.SetContactSrvBtn.TabIndex = 3
        Me.SetContactSrvBtn.Text = "Set&ContactServer"
        Me.SetContactSrvBtn.TextAlign = System.Drawing.ContentAlignment.TopLeft
        '
        'ExitBtn
        '
        Me.ExitBtn.Location = New System.Drawing.Point(8, 20)
        Me.ExitBtn.Name = "ExitBtn"
        Me.ExitBtn.Size = New System.Drawing.Size(110, 25)
        Me.ExitBtn.TabIndex = 0
        Me.ExitBtn.Text = "Ex&it"
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(64, 32)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(376, 16)
        Me.Label2.TabIndex = 2
        Me.Label2.Text = "Copyright (C) 1991-2002 Rainbow Technologies Inc. All rights reserved."
        '
        'GroupBox2
        '
        Me.GroupBox2.Controls.AddRange(New System.Windows.Forms.Control() {Me.ExitBtn})
        Me.GroupBox2.Location = New System.Drawing.Point(624, 504)
        Me.GroupBox2.Name = "GroupBox2"
        Me.GroupBox2.Size = New System.Drawing.Size(126, 58)
        Me.GroupBox2.TabIndex = 3
        Me.GroupBox2.TabStop = False
        '
        'GroupBox3
        '
        Me.GroupBox3.Controls.AddRange(New System.Windows.Forms.Control() {Me.ViewList})
        Me.GroupBox3.Location = New System.Drawing.Point(64, 48)
        Me.GroupBox3.Name = "GroupBox3"
        Me.GroupBox3.Size = New System.Drawing.Size(612, 276)
        Me.GroupBox3.TabIndex = 4
        Me.GroupBox3.TabStop = False
        Me.GroupBox3.Text = "KeyView"
        '
        'ViewList
        '
        Me.ViewList.Font = New System.Drawing.Font("Courier New", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.ViewList.ItemHeight = 14
        Me.ViewList.Location = New System.Drawing.Point(8, 12)
        Me.ViewList.Name = "ViewList"
        Me.ViewList.Size = New System.Drawing.Size(596, 256)
        Me.ViewList.TabIndex = 3
        '
        'form1
        '
        Me.AutoScale = False
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(772, 585)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.GroupBox3, Me.GroupBox2, Me.MiscGroupBox, Me.GroupBox1, Me.APIGroupBox, Me.Label2, Me.Label1, Me.sproLogo})
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.Name = "form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
        Me.Text = "Sentinel SuperPro Evaluation Program"
        Me.MiscGroupBox.ResumeLayout(False)
        Me.GroupBox1.ResumeLayout(False)
        Me.APIGroupBox.ResumeLayout(False)
        Me.GroupBox2.ResumeLayout(False)
        Me.GroupBox3.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    '**************************************************************************
    '* Procedure: sproevalForm_Load
    '*
    '* Purpose  : perform some opertaion at the time of Main form load.
    '*
    ' Descrip   :called Initial view function to display key view i  keyView list box
    '****************************************************************************/

    Private Sub sproevalForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim status As System.Int16
        Try
            '//**************RNBOsproFormatPacket API **********************/
            status = Superpro.RNBOsproFormatPacket(Superpro.packet, Superpro.SPRO_APIPACKET_SIZE)
            If status <> 0 Then
                MessageBox.Show("Error During FormatPacket API call.", "Application Error")
                Close()
                Return
            End If
            Call InitialView() ' call to display KEYVIEW format in list box
            ComboBoxProtocolFlag.SelectedIndex() = 0

        Catch
            MessageBox.Show("Error During API call. Probabily SX32W.dll missing.", "Application Error")
            Close()
        End Try
    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/

    '**************************************************************************
    '* Procedure: FormatPkt_Click
    '*
    '* Purpose  : called on FormatPacket button click
    '*
    ' Descrip   :RNBOsproFormatPacket API call is here
    '****************************************************************************/
    Private Sub FormatPkt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FormatPkt.Click
        Dim status As System.Int16
        '//**************RNBOsproFormatPacket API **********************/
        ComboBoxProtocolFlag.SelectedIndex() = 0
        ServerName.Text = ""
        status = Superpro.RNBOsproFormatPacket(Superpro.packet, Superpro.SPRO_APIPACKET_SIZE)
        'if API successfull then
        If status = 0 Then
            'clear all the input text box
            Call API_Success("FormatPacket")
        Else
            'Diplay API failure messafe with API return code.
            Call API_Fail("FormatPacket", status)
        End If
    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure: InitializeBtn_Click
    '*
    '* Purpose  : called on Initialize button click
    '*
    ' Descrip   :RNBOsproInitialize API call is here
    '****************************************************************************/

    Private Sub InitializeBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InitializeBtn.Click
        Dim status As System.Int16
        status = Superpro.RNBOsproInitialize(Superpro.packet)
        'if API successfull then
        If status = 0 Then
            'clear all the input text box
            Call API_Success("Initialize")
        Else
            'Diplay API failure messafe with API return code.
            Call API_Fail("Initialize", status)
        End If

    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure: SetProtocol_Click
    '*
    '* Purpose  : called on Setprotocol button click
    '*
    ' Descrip   :RNBOsproSetProtocol API call is here
    '****************************************************************************/
    Private Sub SetProtocol_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SetProtocol.Click
        Dim status As System.Int16
        Dim protocolFlag As Int16
        'Get protocol selected element value from ComboBox
        protocolFlag = ComboBoxProtocolFlag.SelectedIndex
        If (protocolFlag = -1) Then 'if protocol flag value is not selected

            MessageBox.Show("Select a value for protocol to proceed.", "SetProtocol", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        Else
            'assign valid constant value for protocol flag defined in Superpro.cs 
            Select Case protocolFlag
                Case 0
                    protocolFlag = Superpro.PROTOCOL_FLAG.NSPRO_TCP_PROTOCOL
                Case 1
                    protocolFlag = Superpro.PROTOCOL_FLAG.NSPRO_IPX_PROTOCOL
                Case 2
                    protocolFlag = Superpro.PROTOCOL_FLAG.NSPRO_NETBEUI_PROTOCOL
                Case 3
                    protocolFlag = Superpro.PROTOCOL_FLAG.NSPRO_SAP_PROTOCOL
            End Select

        End If

        '**************RNBOsproSetProtocol API **********************/
        status = Superpro.RNBOsproSetProtocol(Superpro.packet, protocolFlag)
        ' if API successfull
        If status = 0 Then
            '	// clear all the input text box
            Call API_Success("SetProtocol")
        Else
            '// Diplay API failure messafe with API return code.
            Call API_Fail("SetProtocol", status)
        End If
    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/

    '**************************************************************************
    '* Procedure: SetContactSrvBtn_Click
    '*
    '* Purpose  : Called on SetContactSrv button click
    '*
    ' Descrip   :RNBOsproSetContactServer API call is here
    '****************************************************************************/

    Private Sub SetContactSrvBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SetContactSrvBtn.Click
        Dim status As System.Int16
        Dim serverNameText As String = "" ' string variable for Server value
        'Get Contact server string value entered by user
        serverNameText = ServerName.Text

        ' check Servername for length
        If (serverNameText.Trim().Length > Superpro.MAX_NAME_LEN - 1) Then

            MessageBox.Show("ContactServer name length must not be exceeded 63.", "SetContactServer", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        Else

            '**************RNBOsproSetContactServer API **********************/
            status = Superpro.RNBOsproSetContactServer(Superpro.packet, serverNameText)
            'If API successfull
            If (status = 0) Then
                'clear all input text box on API success
                Call API_Success("SetContactServer")
            Else
                'Diplay API failure messafe with API return code.
                Call API_Fail("SetContactServer", status)
            End If
        End If

    End Sub

    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/

    '**************************************************************************
    '* Procedure: FindFirstBtn_Click
    '*
    '* Purpose  : Called on FindFirstUnit button click
    '*
    ' Descrip   :RNBOsproFindFirstUnit API call is here
    '****************************************************************************/

    Private Sub FindFirstBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FindFirstBtn.Click
        Dim i_IsValid As Int16
        Dim status As System.Int16
        Dim sDevID As String = ""
        Dim DevID As Int32 = 0

        'Get DevID entered by user as string
        sDevID = Input.Text
        'Perform validation for DEVID string value and convert into integer.
        i_IsValid = isValidData(sDevID.Trim(), form1.VALIDDATA_LENGTH, DevID)

        If (i_IsValid = 1) Then 'If DevID is blank
            MessageBox.Show("Specify DeveloperID in input box to proceed.", "FindFirstUnit", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 2) Then 'If DevID string is of invalid length

            MessageBox.Show("DeveloperID must be in hex with length not exceeding 4 digits.", "FindFirstUnit", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 3) Then 'If DevID string is not valid HexString
            MessageBox.Show("DeveloperID must be in hex with length not exceeding 4 digits.", "FindFirstUnit", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        '**************RNBOsproFindFirstUnit API ************'**********/
        status = Superpro.RNBOsproFindFirstUnit(Superpro.packet, DevID)
        'If API successfull
        If (status = 0) Then
            'clear all input text box on API success
            Call API_Success("FindFirstUnit")
        Else
            'Diplay API failure messafe with API return code.
            Call API_Fail("FindFirstUnit", status)
        End If
    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure: FindNextBtn_Click
    '*
    '* Purpose  : Called on FindNextUnit button click
    '*
    ' Descrip   :RNBOsproFindNextUnit API call is here
    '****************************************************************************/

    Private Sub FindNextBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FindNextBtn.Click
        Dim status As System.Int16

        '**************RNBOsproFindNextUnit API **********************/
        status = Superpro.RNBOsproFindNextUnit(Superpro.packet)
        'If API successfull
        If status = 0 Then
            'clear all input text box on API success
            Call API_Success("FindNext")
        Else
            'Diplay API failure messafe with API return code.
            Call API_Fail("FindNext", status)
        End If
    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/

    '**************************************************************************
    '* Procedure: GetContactSrv_Click
    '*
    '* Purpose  : Called on GetContactServer button click
    '*
    ' Descrip   :RNBOsproGetContactServer API call is here
    '****************************************************************************/

    Private Sub GetContactSrv_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GetContactSrv.Click
        Dim status As System.Int16
        ' for server name
        Dim serverNameOut() As Byte = New Byte(Superpro.MAX_NAME_LEN) {}

        '**************RNBOsproGetContactServer API **********************/
        status = Superpro.RNBOsproGetContactServer(Superpro.packet, serverNameOut, 64)
        If status = 0 Then
            'clear all input text box on API success
            Call API_Success("GetContactServer")
            Output.Text = AE.GetString(serverNameOut)

        Else
            'Diplay API failure messafe with API return code.
            Output.Text = ""
            Call API_Fail("GetContactServer", status)
        End If

    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure: HeartBeat_Click
    '*
    '* Purpose  : Called on SetHeartBeat button click
    '*
    ' Descrip   :RNBOsproSetHeartBeat API call is here
    '****************************************************************************/

    Private Sub HeartBeat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HeartBeat.Click
        Dim status As System.Int16
        Dim heartBeat As Int32 = 0
        Dim sHeartBeat As String = ""
        ' get heartbeat value as string 
        sHeartBeat = Input.Text()
        If (sHeartBeat = "") Then ' if heartvalue isblank then
            MessageBox.Show("Specify heartbeat value to proceed.", "SetHeartBeat", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        Else
            Try
                'convert heartbeat value into integer
                heartBeat = CInt(Input.Text)

            Catch
                ' if heartbeat value is not valid integer string
                MessageBox.Show("Heartbeat value must be an integer between 60 to 2592000. Enter -1 for infinite heartbeat.", "SetHeartBeat", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return

            End Try
            'check heart for valid values
            If ((heartBeat = Superpro.INFINITE_HEARTBEAT) Or (heartBeat >= Superpro.MIN_HEARTBEAT And heartBeat <= Superpro.MAX_HEARTBEAT)) Then

                '**************RNBOsproSetHeartBeat API **********************/
                status = Superpro.RNBOsproSetHeartBeat(Superpro.packet, heartBeat)
                If status = 0 Then
                    Call API_Success("SetHeartBeat")
                Else
                    Call API_Fail("SetHeartBeat", status)
                End If
            Else
                'if heartbeat is not valid for API call
                MessageBox.Show("Heartbeat value must be an integer between 60 to 2592000. Enter -1 for infinite heartbeat.", "SetHeartBeat", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If
        End If
    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure: Read_Click
    '*
    '* Purpose  : Called on Read button click
    '*
    ' Descrip   :RNBOsproRead API call is here
    '****************************************************************************/

    Private Sub ReadBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReadBtn.Click
        Dim i_IsValid As Int16
        Dim status As System.Int16
        Dim scellAdd As String = ""
        Dim cellAdd As Int16 = 0
        Dim data As Int32 = 0

        'Get Cell address value as string enterd by user
        scellAdd = CellNumber.Text
        'Perform validation for CellAddress string value and convert into integer.
        i_IsValid = isValidData(scellAdd.Trim, form1.CELLADDRESS_LENGTH, cellAdd)
        If (i_IsValid = 1) Then 'if celladdress value is blank 

            MessageBox.Show("Specify Cell No. to proceed.", "Read", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 2) Then 'if cell address string value length is invalid
            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "Read", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 3) Then 'if celladdress string is in valid hex string

            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "Read", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        '**************RNBOsproRead API **********************/
        status = Superpro.RNBOsproRead(Superpro.packet, cellAdd, data)
        If status = 0 Then
            'clear all input text box on API success
            Call API_Success("Read")
            ' display data read in output box
            Output.Text = Hex(data)


        Else
            'Diplay API failure messafe with API return code.
            Call API_Fail("Read", status)
            Output.Text = ""
        End If

    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure: XRead_Click
    '*
    '* Purpose  : Called on Extendedread button click
    '*
    ' Descrip   :RNBOsproExtendedread API call is here
    '****************************************************************************/

    Private Sub XReadBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles XReadBtn.Click
        Dim i_IsValid As Int16
        Dim status As System.Int16
        Dim scellAdd As String = ""
        Dim cellAdd As Int16 = 0
        Dim data As Int32 = 0
        Dim ACode As Byte = 0

        'Get Cell address value as string enterd by user
        scellAdd = CellNumber.Text
        'Perform validation for CellAddress string value and convert into integer.
        i_IsValid = isValidData(scellAdd.Trim(), form1.CELLADDRESS_LENGTH, cellAdd)
        If (i_IsValid = 1) Then 'if celladdress value is blank 

            MessageBox.Show("Specify Cell No. to proceed.", "ExtendedRead", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 2) Then 'if cell address string value length is invalid
            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "ExtendedRead", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 3) Then 'if celladdress string is in valid hex string

            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "ExtendedRead", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        '**************RNBOsproExtendedRead API **********************/
        status = Superpro.RNBOsproExtendedRead(Superpro.packet, cellAdd, data, ACode)
        If status = 0 Then
            Call API_Success("ExtendedRead")
            Output.Text = Hex(data)
            AccessCode.Text = Hex(ACode)
        Else
            Output.Text = ""
            AccessCode.Text = ""
            Call API_Fail("ExtendedRead", status)
        End If
    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure: Write_Click
    '*
    '* Purpose  : Called on Write button click
    '*
    ' Descrip   :RNBOsproWrite API call is here
    '****************************************************************************/

    Private Sub WriteBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WriteBtn.Click
        Dim i_IsValid As Int16
        Dim status As System.Int16
        Dim scellAdd As String = ""
        Dim sData As String = ""
        Dim sAccessCode As String = ""
        Dim cellAdd As Int16 = 0
        Dim data As Int32 = 0
        Dim ACode As Byte = 0
        'Get Cell address value as string enterd by user
        scellAdd = CellNumber.Text
        'Get data value as string enterd by user
        sData = Input.Text
        'Get AccessCode value as string enterd by user
        sAccessCode = AccessCode.Text
        'Perform validation for CellAddress string value and convert into integer.
        i_IsValid = isValidData(scellAdd.Trim(), CELLADDRESS_LENGTH, cellAdd)
        If (i_IsValid = 1) Then 'if celladdress value is blank 

            MessageBox.Show("Specify Cell No. to proceed.", "ExtendedRead", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 2) Then 'if cell address string value length is invalid
            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "ExtendedRead", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 3) Then 'if cell address string value length is invalid

            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "ExtendedRead", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        'Perform validation for data string value and convert into integer.
        i_IsValid = isValidData(sData.Trim(), VALIDDATA_LENGTH, data) 'if data value is blank 

        If (i_IsValid = 1) Then ' data is blank
            MessageBox.Show("Specify data to be written in input box to proceed.", "Write", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 2) Then 'if data string value length is invalid

            MessageBox.Show("Data to be written must be a hex with length not exceeding 4 digit.", "Write", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 3) Then 'if data string value length is invalid
            MessageBox.Show("Data to be written must be a hex with length not exceeding 4 digit.", "Write", MessageBoxButtons.OK, MessageBoxIcon.Error)

            Return
        End If
        If (sAccessCode = "") Then 'if Accesscode value is blank 
            MessageBox.Show("Specify an Access Code to proceed.", "Write", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        Try
            'convert access code into byte
            ACode = CByte("&H" & sAccessCode)

        Catch

            MessageBox.Show("Access Code must be between 0 to 3.", "Write", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End Try
        If (ACode < MIN_ACCESSCODE_RANGE And ACode > MAX_ACCESSCODE_RANGE) Then 'check for access code value
            MessageBox.Show("Access Code must be between 0 to 3.", "Write", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If ((Not (Key_WritePW)) And (Not (Key_OWritePW))) Then ' check for write password validity

            MessageBox.Show("Specify Write Password using Passwords button to proceed.", "Write", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        '**************RNBOsproWrite API **********************/
        status = Superpro.RNBOsproWrite(Superpro.packet, WritePW, cellAdd, data, ACode)
        'if API get successfull 
        If status = 0 Then
            'clear all input box
            Call API_Success("Write")
        Else
            Call API_Fail("Write", status)
        End If
    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure: Overwrite_Click
    '*
    '* Purpose  : Called on Overwrite button click
    '*
    ' Descrip   :RNBOsproOverwrite API call is here
    '****************************************************************************/

    Private Sub OverwriteBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OverwriteBtn.Click
        Dim i_IsValid As Int16
        Dim status As System.Int16
        Dim scellAdd As String = ""
        Dim sData As String = ""
        Dim sAccessCode As String = ""
        Dim cellAdd As Int16 = 0
        Dim data As Int32 = 0
        Dim ACode As Int16 = 0
        'Get Cell address value as string enterd by user
        scellAdd = CellNumber.Text
        'Get data value as string enterd by user
        sData = Input.Text
        'Get AccessCode value as string enterd by user
        sAccessCode = AccessCode.Text
        'Perform validation for CellAddress string value and convert into integer.
        i_IsValid = isValidData(scellAdd.Trim(), CELLADDRESS_LENGTH, cellAdd)
        If (i_IsValid = 1) Then 'if celladdress value is blank 

            MessageBox.Show("Specify Cell No. to proceed.", "ExtendedRead", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 2) Then 'if cell address string value length is invalid
            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "ExtendedRead", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 3) Then 'if cell address string value length is invalid

            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "ExtendedRead", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        'Perform validation for data string value and convert into integer.
        i_IsValid = isValidData(sData.Trim(), VALIDDATA_LENGTH, data)
        If (i_IsValid = 1) Then ' if data string is blank
            MessageBox.Show("Specify data to be written in input box to proceed.", "Write", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 2) Then 'if data string value length is invalid

            MessageBox.Show("Data to be written must be a hex with length not exceeding 4 digit.", "Write", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 3) Then 'if data string value length is invalid
            MessageBox.Show("Data to be written must be a hex with length not exceeding 4 digit.", "Write", MessageBoxButtons.OK, MessageBoxIcon.Error)

            Return
        End If
        If (sAccessCode = "") Then ' if accesscode string is blank
            MessageBox.Show("Specify an Access Code to proceed.", "Write", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        Try
            'convert accesscode string into byte
            ACode = CInt("&H" & sAccessCode)

        Catch

            MessageBox.Show("Access Code must be between 0 to 3.", "Write", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End Try
        ' check for valid access code value
        If (ACode < MIN_ACCESSCODE_RANGE And ACode > MAX_ACCESSCODE_RANGE) Then
            MessageBox.Show("Access Code must be between 0 to 3.", "Write", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        'validity for write and overwrite passwords value of key
        If (Not (Key_OWritePW)) Then

            MessageBox.Show("Specify Write Password using Passwords button to proceed.", "Write", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        '**************RNBOsproWrite API **********************/
        status = Superpro.RNBOsproOverwrite(Superpro.packet, WritePW, OverWritePW1, OverWritePW2, cellAdd, data, ACode)
        'if API get successfull
        If status = 0 Then
            'clear all input text box
            Call API_Success("Overwrite")
        Else
            'display APi faiure message with PAI return code
            Call API_Fail("Overwrite", status)
        End If

    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure: Query_Click
    '*
    '* Purpose  : Called on Query button click
    '*
    ' Descrip   :RNBOsproQuery API call is here
    '****************************************************************************/

    Private Sub QueryBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles QueryBtn.Click
        Dim status As System.Int16
        Dim scellAdd As String = ""
        Dim cellAdd As Int16 = 0
        Dim i_IsValid As Int16 = -1
        Dim squeryData As String = ""
        Dim resp32 As Long = 0
        'Get Cell address value as string enterd by user
        scellAdd = CellNumber.Text
        'Perform validation for CellAddress string value and convert into integer.
        i_IsValid = isValidData(scellAdd.Trim(), VALIDDATA_LENGTH, cellAdd)
        If (i_IsValid = 1) Then 'if celladdress value is blank 

            MessageBox.Show("Specify Cell No. to proceed.", "Query", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 2) Then 'if cell address string value length is invalid

            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "Query", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 3) Then 'if cell address string value length is invalid

            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "Query", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        'Get Cell address value as string enterd by user
        squeryData = Input.Text
        'Perform validation for querydata string value and convert into integer.
        i_IsValid = isValidQueryData(squeryData.Trim())

        If (i_IsValid = 1) Then 'if querydata value is blank 

            MessageBox.Show("Specify a query string to proceed.", "Query", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 2) Then 'if querydata string value length is invalid

            MessageBox.Show("Query string must be in hex.\n The length of the string must be even and between 8 to 112.", "Query", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 3) Then 'if querydata string value length is invalid HexString

            MessageBox.Show("Query string must be in hex.\n The length of the string must be even and between 8 to 112.", "Query", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        'allocate array for query input and output response
        Dim queryResp() As Byte = New Byte((squeryData.Length / 2) - 1) {}
        Dim queryData() As Byte = New Byte((squeryData.Length / 2) - 1) {}
        ' convert query into array of 1/2 length of char data type
        queryData = ConvertQueryData(squeryData)
        '''********* RNBOsproQuery API call
        status = Superpro.RNBOsproQuery(Superpro.packet, cellAdd, queryData, queryResp, resp32, squeryData.Length / 2)
        ' if API get successful 
        If status = 0 Then
            Call API_Success("Query")
            ' display query response as hexstring 
            Output.Text = ConvertResponse(queryResp)
        Else
            Output.Text = ""
            Call API_Fail("Query", status)
        End If

    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure: ActivateBtn_Click
    '*
    '* Purpose  : Called on Activate button click
    '*
    ' Descrip   :RNBOsproActivate API call is here
    '****************************************************************************/

    Private Sub ActivateBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActivateBtn.Click
        Dim status As System.Int16
        Dim scellAdd As String = ""
        Dim cellAdd As Int16 = 0
        Dim i_IsValid As Int16 = -1

        'Get Cell address value as string enterd by user
        scellAdd = CellNumber.Text
        'Perform validation for CellAddress string value and convert into integer.
        i_IsValid = isValidData(scellAdd, CELLADDRESS_LENGTH, cellAdd)
        If (i_IsValid = 1) Then 'if celladdress value is blank 

            MessageBox.Show("Specify Cell No. to proceed.", "Activate", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 2) Then 'if cell address string value length is invalid

            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "Activate", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 3) Then 'if cell address string value length is invalid

            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "Activate", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        If ((Not (Key_WritePW)) And (Not (Key_OWritePW))) Then ' check for write password validity

            MessageBox.Show("Specify Write Password using Passwords button to proceed.", "Activate", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        'display Activate form to seek Activate passwords
        Dim ActivateFormForm As Activate = New Activate()
        If (ActivateFormForm.ShowDialog() = DialogResult.OK) Then
            'if enterd Activate passwords arer valid then
            '**************RNBOsproActivate API **********************/
            status = Superpro.RNBOsproActivate(Superpro.packet, WritePW, AP1, AP2, cellAdd)
            If status = 0 Then
                Call API_Success("Activate")
            Else
                Call API_Fail("Activate", status)
            End If
        End If

    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure: DecrementBtn_Click
    '*
    '* Purpose  : Called on Decrement button click
    '*
    ' Descrip   :RNBOsproDecrement API call is here
    '****************************************************************************/

    Private Sub DecrementBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DecrementBtn.Click
        Dim i_IsValid As Int16 = -1
        Dim status As System.Int16
        Dim scellAdd As String = ""
        Dim cellAdd As Int16 = 0

        'Get Cell address value as string enterd by user
        scellAdd = CellNumber.Text
        'Perform validation for CellAddress string value and convert into integer.
        i_IsValid = isValidData(scellAdd.Trim(), CELLADDRESS_LENGTH, cellAdd)
        If (i_IsValid = 1) Then ' if blank value

            MessageBox.Show("Specify Cell No. to proceed.", "Read", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 2) Then
            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "Read", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 3) Then

            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "Read", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If ((Not (Key_WritePW)) And (Not (Key_OWritePW))) Then ' check for write password validity

            MessageBox.Show("Specify Write Password using Passwords button to proceed.", "Write", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        '**************RNBOsproDecrement API **********************/
        status = Superpro.RNBOsproDecrement(Superpro.packet, WritePW, cellAdd)
        If status = 0 Then
            Call API_Success("Decrement")
        Else
            Call API_Fail("Decrement", status)
        End If

    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure: VersionBtn_Click
    '*
    '* Purpose  : Called on GetVersion button click
    '*
    ' Descrip   :RNBOsproGetVersion API call is here
    '****************************************************************************/

    Private Sub VersionBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VersionBtn.Click
        Dim status As System.Int16
        Dim maj As Byte = 0
        Dim min As Byte = 0
        Dim rev As Byte = 0
        Dim ostype As Byte = 0


        '**************RNBOsproGetVersion API **********************/
        status = Superpro.RNBOsproGetVersion(Superpro.packet, maj, min, rev, ostype)
        'if success then
        If status = 0 Then

            Call API_Success("GetVersion")
            Dim driverType As String = ""
            ' generate constant OS type string for OS type value
            Select Case ostype

                Case Superpro.RB_WINNT_SYS_DRVR
                    driverType = CStr(ostype) + " (Windows NT system driver)"
                Case Superpro.RB_WIN95_SYS_DRVR
                    driverType = CStr(ostype) + " Windows 95 system driver)"

                Case Superpro.RB_NW_LOCAL_DRVR
                    driverType = CStr(ostype) + " (Novell system driver)"

                Case 10
                    driverType = ostype + " (Unknown driver type)"
            End Select
            'display version info
            MessageBox.Show("Major Version : " + CStr(maj) + ", " + "Minor Version : " + CStr(min) + " , " + "Revision : " + CStr(rev) + " , " + "OS Driver Type : " + driverType, "GetVersion", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            Call API_Fail("GetVersion", status)
        End If


    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure: GetHardLimit
    '*
    '* Purpose  : perform some opertaion at the time of Main form load.
    '*
    ' Descrip   :called Initial view function to display key view i  keyView list box
    '****************************************************************************/
    '/***** called on GetHardLimit button click**************/
    Private Sub GetHardLmt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GetHardLmt.Click
        Dim status As System.Int16
        Dim hardLimit As Int32 = 0

        '**************RNBOsproGetHardLimit API **********************/
        status = Superpro.RNBOsproGetHardLimit(Superpro.packet, hardLimit)
        'if success
        If status = 0 Then
            'clear all input box on success
            Call API_Success("GetHardLimit")
            ' display hardlimit value in Output box
            Output.Text = CStr(CInt(hardLimit))
        Else
            Output.Text = ""
            Call API_Fail("GetHardLimit", status)
        End If

    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure:StatusBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitBtn.Click
    '*
    '* Purpose  : Called on GetFullStatus button click
    '*
    ' Descrip   :RNBOsproGetFullStatus API call is here
    '****************************************************************************/

    Private Sub StatusBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StatusBtn.Click
        Dim status As System.Int16
        '**************RNBOsproGetFullstatus API **********************/
        status = Superpro.RNBOsproGetFullStatus(Superpro.packet)
        CellNumber.Text = ""
        AccessCode.Text = ""
        Input.Text = ""
        Output.Text = ""
        StatusLine.Items.Clear()
        StatusLine.Items.Add("GetFullStatus successful!")
        StatusLine.Items.Add("Status of last API called is " + CStr(status) + ".")
    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/

    '**************************************************************************
    '* Procedure:KeyInfo_Click
    '*
    '* Purpose  : Called on KeyInfo button click
    '*
    ' Descrip   :RNBOsproKeyInfo API call is here
    '****************************************************************************/

    Private Sub KeyInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles KeyInfo.Click
        'display keyinfo form for key info value
        Dim KeyInfoForm As KeyInfo = New KeyInfo()
        KeyInfoForm.ShowDialog()
    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure:GetSubLicBtn_Click
    '*
    '* Purpose  : Called on GetSubLicense button click
    '*
    ' Descrip   :RNBOsproGetSubLicense API call is here
    '****************************************************************************/

    Private Sub GetSubLicBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GetSubLicBtn.Click

        Dim i_IsValid As Int16 = -1
        Dim status As System.Int16
        Dim scellAdd As String = ""
        Dim cellAdd As Int16 = 0
        'Get Cell address value as string enterd by user
        scellAdd = CellNumber.Text
        'Perform validation for CellAddress string value and convert into integer.
        i_IsValid = isValidData(scellAdd, 2, cellAdd)
        If (i_IsValid = 1) Then 'if celladdress value is blank 

            MessageBox.Show("Specify Cell No. to proceed.", "Read", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 2) Then 'if cell address string value length is invalid
            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "Read", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 3) Then

            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "Read", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        '**************RNBOsproGetSubLicense API **********************/
        status = Superpro.RNBOsproGetSubLicense(Superpro.packet, cellAdd)
        ' if API get success
        If status = 0 Then
            'clear all input text box
            Call API_Success("GetSubLicense")
        Else
            'display message for PAI failure
            Call API_Fail("GetSubLicense", status)
        End If

    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure:ReleaseLicBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitBtn.Click
    '*
    '* Purpose  : Called on ReleaseLicense button click
    '*
    ' Descrip   :RNBOsproReleaseLicense API call is here
    '****************************************************************************/

    Private Sub ReleaseLicBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReleaseLicBtn.Click
        Dim i_IsValid As Int16 = -1
        Dim status As System.Int16
        Dim scellAdd As String = ""
        Dim cellAdd As Int16 = 0
        Dim snumLic As String = ""
        Dim numLic As Int32 = 0
        'Get Cell address value as string enterd by user
        scellAdd = CellNumber.Text
        'Perform validation for CellAddress string value and convert into integer.
        i_IsValid = isValidData(scellAdd.Trim(), CELLADDRESS_LENGTH, cellAdd)
        If (i_IsValid = 1) Then 'if celladdress value is blank 

            MessageBox.Show("Specify Cell No. to proceed.", "Read", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 2) Then 'if cell address string value length is invalid
            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "Read", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (i_IsValid = 3) Then 'if cell address string value length is invalid

            MessageBox.Show("Cell No. must be a hex with length not exceeding 2 digit.", "Read", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        'get NumLIc value as string entered by user 
        snumLic = Input.Text
        If (snumLic = "") Then 'if blank then
            MessageBox.Show("Specify numLic to proceed.", "ReleaseLicense", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        If (snumLic.Length > 5) Then 'check for NumLic string value length to avoid exception
            MessageBox.Show("Number of sublicense to release must be an integer between 0 to 65535.", "ReleaseLicense", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If


        Try
            'convert Numlic from string to integer
            numLic = CInt(snumLic)

        Catch

            MessageBox.Show("Number of sublicense to release must be an integer between 0 to 65535.", "ReleaseLicense", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return

        End Try
        'check for valid value of numlic
        If ((numLic < 0 Or numLic > 65535)) Then

            MessageBox.Show("Number of sublicense to release must be an integer between 0 to 65535.", "ReleaseLicense", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If

        '**************RNBOsproReleaseLicense API **********************/
        status = Superpro.RNBOsproReleaseLicense(Superpro.packet, cellAdd, numLic)
        ' if APi get successfull
        If status = 0 Then
            'clear all input box
            Call API_Success("ReleaseLicense")
        Else
            'display message
            Call API_Fail("ReleaseLicense", status)
        End If
    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure:EnumServerBtn_Click
    '*
    '* Purpose  : Called on EnumServer button click
    '*
    ' Descrip   :RNBOsproEnumServer API call is here
    '****************************************************************************/

    Private Sub EnumSever_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EnumSever.Click
        'display enumServer form for EnumServer API
        Dim EnumForm As EnumServer = New EnumServer()
        EnumForm.ShowDialog()
    End Sub
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/

    '**************************************************************************
    '* Procedure:KeyView_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitBtn.Click
    '*
    '* Purpose  : Called on KeyView button click
    '*
    ' Descrip   :This function is to show View of Key
    '****************************************************************************/

    Private Sub ViewBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ViewBtn.Click
        Dim i As Int16
        Dim status As System.Int16
        Dim scellAdd As String = ""
        Dim cellAdd As Int16 = 0
        Dim data As Int32 = 0
        Dim ACode As Byte = 0
        Dim a As Int16 = 0 '// loop variable;
        Dim b As Int16 = 0 '// loop variable;
        Dim gViewText As String = "" 'string variable to display in keyview list box
        '// Heading for key view
        Dim viewString As String = "    Adr    Data    AC   Adr    Data    AC   Adr    Data    AC   Adr    Data    AC      "
        '// some temparary string variable to make key view allign properly
        Dim space_pad1 As String = ""
        Dim space_pad2 As String = ""
        Dim space_pad3 As String = ""
        Dim space_pad4 As String = ""
        '//clear  elements of List box
        ViewList.Items.Clear()
        '// add first element as heading of keyView list box
        ViewList.Items.Add(viewString)
        '// formating for keyview
        viewString = "    ---    ----    --   ---    ----    --   ---    ----    --   ---    ----    --    "
        ViewList.Items.Add(viewString)
        '// loop to display 16 rows in key view list box
        Do
            '// assingn blank to temp string variables used for allignment
            gViewText = ""
            space_pad1 = ""
            space_pad2 = ""
            space_pad3 = ""
            space_pad4 = ""
            b = 0
            '// loop to make 4 cell key data in each row of list box
            Do
                space_pad4 = "".PadLeft(4) '//For just allignment and formmating of key view
                space_pad1 = Convert.ToString(a + 16 * b, 16).PadLeft(2) '// calculate celladdress value in hex
                data = 0
                ACode = 0
                ' Call RNBOsproExtendedRead API to display key view
                status = Superpro.RNBOsproExtendedRead(Superpro.packet, (a + 16 * b), data, ACode)
                'if API get successfull
                If (status <> 0) Then

                    space_pad2 = "????".PadLeft(9) '//For just allignment and formmating of key view
                    If (status = 4) Then 'if API return code is 4 then
                        space_pad3 = "3".PadLeft(5) '// display 3 as access code of cell data
                    Else
                        space_pad3 = "?".PadLeft(5) '//else display unknown accessCode(?)
                    End If
                    '//concat one string to display one cell view
                    gViewText = gViewText + space_pad4 + space_pad1 + space_pad2 + space_pad3
                Else
                    '//If API succesfull
                    space_pad2 = Convert.ToString(data, 16).PadLeft(4, "0") 'cell data
                    space_pad3 = Convert.ToString(ACode, 16).PadLeft(1) 'accesscode
                    Dim space_pad5 As String = "".PadLeft(5) 'For just allignment and formmating of key view
                    Dim space_pad6 As String = "".PadLeft(4) 'For just allignment and formmating of key view
                    '//concat one string to display one cell view
                    gViewText = gViewText + space_pad4 + space_pad1 + space_pad5 + space_pad2 + space_pad6 + space_pad3

                End If

                b = b + 1
            Loop Until (b > 3)
            'convert into upercase
            gViewText.ToUpper()
            ' add row in ListBOX
            ViewList.Items.Add(gViewText.ToUpper())
            a = a + 1
        Loop Until (a > 15)

    End Sub

    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure:PasswordBtn_Click
    '*
    '* Purpose  : Called on Password button click
    '*
    ' Descrip   :This function is to Password dialog box to enter write and overwrite password of key
    '****************************************************************************/

    Private Sub PasswordBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PasswordBtn.Click
        '//display password form to seek key passwords form user
        Dim PasswordForm As Passwords = New Passwords()
        PasswordForm.ShowDialog()
    End Sub


    '**************************************************************************
    '* Procedure:ExitBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitBtn.Click
    '*
    '* Purpose  : Called on Exit button click
    '*
    ' Descrip   :This function is to call releaseLicense API at the time of application exit
    '****************************************************************************/
    '/***** called on Exit button click**************/
    Private Sub ExitBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitBtn.Click
        Dim status As Int16 = 0
        '// call RNBOsproReleaseLicense API to release all the license issued for this client
        status = Superpro.RNBOsproReleaseLicense(Superpro.packet, 0, 0)
        Close()
    End Sub

    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure:API_Success(ByRef API As String)
    '*
    '* Purpose  : This will call when API get success.
    '*
    '  Descrip   : THis is used to clear diff. input box when API get success.
    '****************************************************************************/

    Private Sub API_Success(ByRef API As String)

        If (API.Equals("FormatPacket") Or API.Equals("Initialize") Or API.Equals("SetContactServer") Or API.Equals("SetProtocol") Or _
            API.Equals("FindFirstUnit") Or API.Equals("FindNextUnit") Or API.Equals("SetHeartBeat") Or API.Equals("Write") Or _
            API.Equals("Overwrite") Or API.Equals("Activate") Or API.Equals("Decrement") Or API.Equals("GetVersion") Or _
            API.Equals("GetSubLicense") Or API.Equals("ReleaseLicense")) Then
            CellNumber.Text = ""
            AccessCode.Text = ""
            Input.Text = ""
            Output.Text = ""
            StatusLine.Items.Clear()
            StatusLine.Items.Add(API + " successful!")
        End If
        If (API.Equals("Read") Or API.Equals("GetHardLimit") Or API.Equals("GetContactServer") Or API.Equals("Query")) Then
            CellNumber.Text = ""
            AccessCode.Text = ""
            Input.Text = ""
            StatusLine.Items.Clear()
            StatusLine.Items.Add(API + " successful!")
        End If
        If (API.Equals("ExtendedRead")) Then
            CellNumber.Text = ""
            Input.Text = ""
            StatusLine.Items.Clear()
            StatusLine.Items.Add(API + " successful!")
        End If

    End Sub

    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure:API_Fail(ByRef API As String, ByVal RetCode As Int16)
    '*
    '* Purpose  : This will call when API get fail
    '*
    '  Descrip   : THis is used to display API return code when API failed.
    '****************************************************************************/

    Private Sub API_Fail(ByRef API As String, ByVal RetCode As Int16)

        StatusLine.Items.Clear()
        StatusLine.Items.Add(API + " failed!")
        StatusLine.Items.Add("Return code is " + RetCode.ToString() + ".")

    End Sub

    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure:isValidData(ByRef thisString As String, ByVal length As Integer, ByRef OutData As Int32) As Int16
    '*
    '* Purpose  : This will call to validate different user inputs.
    '*
    '  Descrip   : THis is used to to check valid hex string and valid length of inputs.
    '****************************************************************************/

    Public Shared Function isValidData(ByRef thisString As String, ByVal length As Integer, ByRef OutData As Int32) As Int16
        If (thisString.Length <= 0) Then
            '// if string blank then retun 1
            Return 1
        End If
        If (thisString.Length > length) Then
            '	// if string length is invalid then return 2
            Return 2
        End If
        If (ConvHexData(thisString, OutData) = -1) Then
            '// string is not valid hex string then return 3
            Return 3
        End If
        Return 0
    End Function

    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/

    '**************************************************************************
    '* Procedure:ConvHexData(ByRef thisString As String, ByRef OutData As Int32) As Int16
    '*
    '* Purpose  : This will call to convert hexstring into integer value
    '****************************************************************************/

    Public Shared Function ConvHexData(ByRef thisString As String, ByRef OutData As Int32) As Int16
        Dim i As Int16 = 0
        'Convert hex string into integer
        Try
            OutData = CInt("&H" & thisString)
        Catch
            Return -1
        End Try

        Return 0
    End Function

    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure:InitialView()
    '*
    '* Purpose  : Display key view on form load time**************/
    '****************************************************************************/

    Sub InitialView()
        Dim i As Int16
        Dim status As System.Int16
        Dim scellAdd As String = ""
        Dim cellAdd As Int16 = 0
        Dim data As Int32 = 0
        Dim ACode As Byte = 0
        Dim a As Int16 = 0 '// loop variable;
        Dim b As Int16 = 0 '// loop variable;
        Dim gViewText As String = "" 'string variable to display in keyview list box
        Dim viewString As String = "    Adr    Data    AC   Adr    Data    AC   Adr    Data    AC   Adr    Data    AC      "
        '// some temparary string variable to make key view allign properly
        Dim space_pad1 As String = ""
        Dim space_pad2 As String = ""
        Dim space_pad3 As String = ""
        Dim space_pad4 As String = ""
        ViewList.Items.Clear()
        ViewList.Items.Add(viewString)
        viewString = "    ---    ----    --   ---    ----    --   ---    ----    --   ---    ----    --    "
        ViewList.Items.Add(viewString)

        '// loop to display 16 rows in key view list box
        Do

            gViewText = ""

            space_pad1 = ""
            space_pad2 = ""
            space_pad3 = ""
            space_pad4 = ""
            b = 0
            '// loop to make 4 cell key data in each row of list box
            Do
                '	for ( b = 0; b < 4; b++ )


                space_pad4 = "".PadLeft(4) '//For just allignment and formmating of key view
                space_pad1 = Convert.ToString(a + 16 * b, 16).PadLeft(2)
                space_pad2 = "????".PadLeft(9) '//For just allignment and formmating of key view
                space_pad3 = "?".PadLeft(5) '//For just allignment and formmating of key view
                gViewText = gViewText + space_pad4 + space_pad1 + space_pad2 + space_pad3
                b = b + 1
            Loop Until (b > 3)

            gViewText.ToUpper()
            ViewList.Items.Add(gViewText.ToUpper())
            a = a + 1
        Loop Until (a > 15)
    End Sub

    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure:isValidQueryData(ByRef input As String) As Int16
    '*
    '* Purpose  : perform some validation on qyery data
    '****************************************************************************/

    Public Function isValidQueryData(ByRef input As String) As Int16

        Dim thisString As String = ""
        Dim stringLength As Int16 = 0
        thisString = input.ToUpper()
        stringLength = thisString.Length
        Dim i As Int16 = 0
        If (thisString.Length <= 0) Then
            '//check for even length query data
            Return 1
        End If
        If (thisString.Length > Superpro.SPRO_MAX_QUERY_SIZE * 2 Or thisString.Length < 8 Or (Int((thisString.Length Mod 2)) <> 0)) Then
            Return 2
        End If

        Dim singleChar As Char
        '// check for valid hex string
        While i < thisString.Length
            singleChar = thisString.Chars(i)
            Dim tempint As Int16 = 0
            Try
                tempint = CInt("&H" & singleChar)
            Catch
                '		// if not a vallid hex character then return 3
                Return 3
            End Try
            i = i + 1
        End While

        Return 0
    End Function
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure:isValidQueryData(ByRef input As String) As Int16
    '*
    '* Purpose  : Convert input query data in byte
    '****************************************************************************/

    Public Function ConvertQueryData(ByVal input As String) As Byte()

        Dim i As Int16 = 0
        Dim j As Int16 = 0
        Dim singleChar As Char
        Dim singleChar1 As Char
        Dim queryBuffer As Byte()
        '//here we will convert query string into array of length /2 of byte
        Dim thisString As String
        Dim stringLength
        Dim hiByte As Int16
        Dim loByte As Int16
        thisString = input.ToUpper()
        stringLength = thisString.Length
        queryBuffer = New Byte((stringLength / 2) - 1) {}
        For i = 0 To (thisString.Length - 1) Step 2
            '//get ith character from input query string
            singleChar = thisString.Chars(i)
            '	//get ith +1 character from input query string
            singleChar1 = thisString.Chars(i + 1)
            '//convert ith character into there aschi value
            If ((singleChar >= "0") And (singleChar <= "9")) Then
                hiByte = CInt((Asc(singleChar) - 48) * 16)
            Else
                hiByte = CInt((Asc(singleChar) - 55) * 16)
            End If
            If ((singleChar1 >= "0") And (singleChar1 <= "9")) Then
                loByte = CInt(Asc(singleChar1) - 48)
            Else
                loByte = CInt(Asc(singleChar1) - 55)
            End If
            '//add ascii value of ith and ith+1 character and assign to jth element of 
            'array of length/2 of byte data type
            queryBuffer(j) = CByte(hiByte + loByte)
            j = j + 1
        Next i
        Return queryBuffer

    End Function
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure:ConvertResponse(ByRef charString As Byte()) As String
    '*
    '* Purpose  : Convert query response in readable char
    '****************************************************************************/

    Function ConvertResponse(ByRef charString As Byte()) As String
        Dim hexValueBuffer As New StringBuilder()
        Dim RevhexValueBuffer As New StringBuilder()
        Dim i As Int16
        Dim j As Int16
        '//convert query response to hex string
        For i = 0 To (charString.Length - 1) Step 1
            hexValueBuffer.Append(IntToHex(charString(i), 2))

        Next i
        For j = 0 To (hexValueBuffer.Length - 1) Step 2

            RevhexValueBuffer.Append(hexValueBuffer(j + 1))
            RevhexValueBuffer.Append(hexValueBuffer(j))

        Next j

        Return RevhexValueBuffer.ToString()
    End Function

    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    '**************************************************************************
    '* Procedure:ConvertResponse(ByRef charString As Byte()) As String
    '*
    '* Purpose  : IntToHex(ByVal decValue As Integer, ByVal length As Int16) As String
    '****************************************************************************/
    Function IntToHex(ByVal decValue As Integer, ByVal length As Int16) As String

        Dim hexValueBuffer As New StringBuilder()
        Dim hexChar As Char
        Dim quotient As Integer = decValue
        Dim remainder As Integer
        Dim count As Integer = 0
        '// convert response into double length hex string to display valid hex query response for user
        While ((quotient > 0) Or (count < length))

            remainder = quotient Mod 16
            If (remainder <= 9) Then
                hexChar = Chr(remainder + 48)
            Else
                hexChar = Chr(remainder + 55)
            End If
            hexValueBuffer.Append(hexChar)
            quotient = quotient \ 16
            count = count + 1
        End While

        Return (hexValueBuffer.ToString())
    End Function
    '**************************************************************************
    ' END OF FUNCTION
    '****************************************************************************/
    Friend WithEvents ViewList As System.Windows.Forms.ListBox
    Friend WithEvents GroupBox3 As System.Windows.Forms.GroupBox
End Class

'**************************************************************************
' END OF CLASS
'****************************************************************************/
